<%!
  from lonote.im3 import Book, Paper
  import hashlib
  path_template = '/edit/{bid}/{pid}/{sid}.html'
%>
<%
  resultspage.results.fragmenter.maxchars = 20
  resultspage.results.fragmenter.surround = 20
%>

<%def name="page_selector(current_pagenum)">
  <div class="btn-group">
  % for pagenum in range(1, min(resultspage.pagecount, 10) + 1):
    % if pagenum == current_pagenum:
      <button type="button" class="btn btn-default btn-sm active">
        ${pagenum}
      </button>
    % else:
      <button type="button" class="btn btn-default btn-sm" onclick="get_result(${pagenum})">
        ${pagenum}
      </button>
    % endif
  % endfor
  </div>
</%def>

<%def name="result_item(hit)">
  <%
    book = bs[hit['bid']]

    target_sid_path = hit['path']
    target_sid_desc = book.paper(hit['pid']).sections.data_meta(hit['sid']).get('desc')
    default_sid_path = path_template.format(
      bid = hit['bid'], pid = hit['pid'], sid = Paper.default_sid)

    book_path = '/edit/{bid}/{pid}/{sid}.html'.format(
      bid = hit['bid'], pid = book.rootpid, sid = Paper.default_sid)

    parent_name = None
    parent_path = ''
    try:
      parent_paper = book.paper(book.pid_parent(hit['pid']))
      parent_name = parent_paper.name
      parent_path = path_template.format(
        bid = hit['bid'], pid = parent_paper.pid,
        sid = Paper.default_sid)
    except: pass

    string = hit['bid'] + hit['pid']
    md5hex = hashlib.md5(string.encode('utf8')).hexdigest()

    highlight = ''
    try:
      highlight = hit.highlights('text', top = 3, minscore = 1)
    except: pass
    if highlight:
      margin = 'margin: 5px;'
    else:
      margin = 'margin: -3px 5px;'
  %>
  <li class="list-group-item">
    <button type="button" class="btn btn-default btn-sm pull-left" search-result-tooltip data-html="true" data-title="&lt;span class=&quot;glyphicon glyphicon-folder-open&quot;&gt;&lt;/span&gt; ${parent_name | h} &lt;br/&gt; &lt;span class=&quot;glyphicon glyphicon-book&quot;&gt;&lt;/span&gt; ${book.name | h}" data-placement="top" style="${margin}" onclick="lo_search_to_bsm('${md5hex}');"><span class="glyphicon glyphicon-book"></span> <span style="position: static;" class="glyphicon glyphicon-arrow-left"></span> </button>
    <span class="list-group-item-text">
      % if hit['sid'] == Paper.default_sid:
        <a href="${target_sid_path | h}"><span class="label label-info pull-right" style="margin: 5px;" search-result-tooltip data-title="${ target_sid_desc | h}">${hit['sid'] | h}</span></a>
      % else:
        <a href="${target_sid_path | h}"><span class="label label-warning pull-right" style="margin: 5px;" search-result-tooltip data-title="${ target_sid_desc | h}">${hit['sid'] | h}</span></a>
      % endif
    </span>
    <a class="list-group-item-heading" search-result-tooltip data-title="${hit['pdesc'] | h}" href="${default_sid_path | h}">${hit['pname'] | h}</a>
    <p class="list-group-item-text" style="margin-left: 1em;"><small>${highlight}</small></p>
  </li>
</%def>

<div class="panel panel-info">
  <div class="panel-heading">
    <%
      start_from = max(resultspage.offset + 1, 0)
      end_to = resultspage.offset + resultspage.pagelen
      hit_count = len(resultspage)
    %>
    ${_('Search Results of [ <b>{}</b> ]:').format(key)}
    ${start_from} - ${end_to}
    / <span search-result-tooltip data-title="${_('Hits Number') | h}">${hit_count}</span>
    <span class="text-muted" style="font-size: smaller;"> // <span search-result-tooltip data-title="${_('Total Sections Number') | h}">${doc_count}</span> </span>
  </div>
  <div class="panel-body">
    <ul class="list-group" id="lo-data-search">
      % for hit in resultspage:
        ${result_item(hit)}
      % endfor
    </ul>
  </div>
  <div class="panel-footer">
    <div class="text-center">
      ${page_selector(resultspage.pagenum)}
    </div>
  </div>
</div>

<script>
</script>
