<%!
  from lonote.im3 import Paper
%>

<%inherit file="base.mako"/>
<%page args="book, paper, sid"/>

<%block name="lo_head_title">
  ${paper.name | h}
  % if sid != Paper.default_sid:
    (${sid | h})
  % endif
  - ${book.name | h}
  ## % if config.get('SITEINFO', 'site_name'):
  ##   - ${config.get('SITEINFO', 'site_name')}
  ## % endif
</%block>

<%block name="lo_head_append">
  <%
    appended_head = ''
    try: appended_head = book.toybox.data_entity('appended.head')
    except: pass
  %>
  ${appended_head}
</%block>

<%block name="lo_nav_header">
  <a id="lo-nav-title" class="navbar-brand" data-toggle="modal" popover data-trigger="hover" data-content="${paper.desc | h}" data-placement="auto" data-container="" href="#lo-papermenu-modal"> ${paper.name | h} </a>

  <a id="lo-nav-sid" class="navbar-brand" style="padding-left: 1px; padding-right: 1px;" popover data-trigger="hover" data-content="${paper.sections.data_meta(sid).get('desc') | h}" data-placement="bottom" data-container="false" data-toggle="modal" href="#lo-sid-modal">
    <span id="lo-nav-sid-label" class="label label-info">${sid | h}</span>
  </a>
</%block>

<%namespace file="element.mako" import="*"/>

<%block name="lo_papermenu_modal" args="book, paper, sid">
  ${modal_edit_papermenu(book, paper, sid)}
</%block>




<%block name="lo_article_content">${paper.sections.data_entity(sid)}</%block>





<%block name="lo_nav_tools">
  <div class="btn-group">
    % if 'e' in a_type:
      ${btn_save()}
    % endif
    ${btn_search()}
    ${btn_bookshelf()}
    ${btn_ioc()}
    ${btn_configure_paper()}
  </div>
</%block>

<%block name="lo_data">

  <!-- sid select modal -->
  <div class="modal" id="lo-sid-modal" tabindex="-1" role="dialog" aria-labelledby="lo-sid-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 class="modal-title">${_('Go to Other Sections') | h}</h4>
        </div>
        <div class="modal-body">
          <div class="list-group" id="lo-data-search">

          <%
            xid_descs = [ (xid, paper.sections.data_meta(xid).get('desc'))
            for xid in paper.sections.ids ]
            xid_descs.sort(key = lambda x: ('', '') if x[0] == Paper.default_sid else x)
          %>
          % for xid, desc in xid_descs:
            % if sid == xid:
              <a class="list-group-item" style="cursor: pointer;" onclick="$('#lo-sid-modal').modal('hide');">
            % else:
              <a class="list-group-item" href="${xid | h}.html">
            % endif
              % if xid == type(paper).default_sid:
                <span class="label label-info">${xid | h}</span>
              % else:
                <span class="label label-warning">${xid | h}</span>
              % endif
              % if sid == xid:
              <span class="label label-success pull-right"><span class="glyphicon glyphicon-pencil"></span></span>
              % endif
              <br/>
              <span style="color: gray; font-size: small; margin-left: 2em;">${desc | h}</span>
            </a>
          % endfor
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->
  <script>
    $('#lo-sid-modal').on('show.bs.modal', function(){
      $('.modal').modal('hide');
      selSave();
    });
    $('#lo-sid-modal').on('hidden.bs.modal', function(){
      selRestore();
    });
    shortcut.add('Alt+S',function() {
      $('#lo-sid-modal').modal('toggle');
    });
  </script>

  ${modal_search()}
  ${modal_bookshelf()}
  ${modal_ioc()}
  ${modal_configure_paper()}
  ${papermeta(book, paper, sid)}
  ${script_save()}
</%block>

<%block name="append_script">

  <!-- not default sid hint -->
  <script>
    % if sid != type(paper).default_sid:
      $('#lo-nav-sid-label').removeClass('label-info');
      $('#lo-nav-sid-label').addClass('label-warning');
    % endif
  </script>

  <!-- Color change -->
  <div class="modal" id="lo-colorchange-modal" tabindex="-1" role="dialog" aria-labelledby="lo-colorchange-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-colorchange-modal-title" class="modal-title">${_('Color Change')}</h4>
        </div>
        <div id="lo-colorchange-modal-body" class="modal-body">
          <div class="input-group">
            <input id='lo-colorchange-modal-input' type="color" class="form-control" value="#F8A400">
            <span class="input-group-btn">
              <button id="lo-colorchange-modal-back-btn" class="btn btn-default" type="button">${_('Background')}</button>
              <button id="lo-colorchange-modal-front-btn" class="btn btn-default" type="button">${_('Text')}</button>
            </span>
          </div>
          <br/>
          <canvas class="center-block" style="cursor: pointer;" width="200" height="40" id="lo-colorchange-picker"></canvas>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->
  <script>
    function lo_colorchange_init(){
      $('#lo-colorchange-modal').on('show.bs.modal', function(){
        selSave();
      });
      $('#lo-colorchange-modal').on('hidden.bs.modal', function(){
        selRestore();
      });
      $('#lo-colorchange-modal-front-btn').on('click', function(){
        $('#lo-colorchange-modal').modal('hide');
        selRestore();
        var color = $('#lo-colorchange-modal-input').val();
        document.execCommand('foreColor', false, color);
        color_save();
      });
      $('#lo-colorchange-modal-back-btn').on('click', function(){
        $('#lo-colorchange-modal').modal('hide');
        selRestore();
        var color = $('#lo-colorchange-modal-input').val();
        document.execCommand('hiliteColor', false, color);
        color_save();
      });
      // canvas color picker
      var canvas = document.getElementById('lo-colorchange-picker').getContext('2d');
      var img = new Image();
	  img.src = '/static/lonote/palette.png'; // source image
      // draw to the canvas
      $(img).load(function(){
        canvas.drawImage(img,0,0);
      });
      // http://www.javascripter.net/faq/rgbtohex.htm
      function rgbToHex(R,G,B) {return toHex(R)+toHex(G)+toHex(B)}
      function toHex(n) {
        n = parseInt(n,10);
        if (isNaN(n)) return "00";
        n = Math.max(0,Math.min(n,255));
        return "0123456789ABCDEF".charAt((n-n%16)/16)  + "0123456789ABCDEF".charAt(n%16);
      }
      $('#lo-colorchange-picker').click(function(event){
        // getting user coordinates
        var offset = $(this).offset();
        var x = event.pageX - offset.left;
        var y = event.pageY - offset.top;
        // getting image data and RGB values
        var img_data = canvas.getImageData(x, y, 1, 1).data;
        var R = img_data[0];
        var G = img_data[1];
        var B = img_data[2];
        // convert RGB to HEX
        var hex = rgbToHex(R,G,B);
        // making the color the value of the input
        $('#lo-colorchange-modal-input').val('#' + hex);
      });
      // color_used load
      function color_load(){
        var color_used = localStorage['color_used'];
        if (color_used){
          $('#lo-colorchange-modal-input').val(color_used);
        }
      };
      color_load();
      // color_used save
      function color_save(){
        var color_used = $('#lo-colorchange-modal-input').val();
        localStorage['color_used'] = color_used;
      };
    }
    lo_colorchange_init();
  </script>

  <!-- Image Scroll -->
  <script>
    function get_mouse_scroll(e){
      var scroll = 0; //滾動格數，滾輪往上滾為正值
      if (e.wheelDelta){ //chrome
        scroll = (e.wheelDelta/120);
      } else if (e.detail){//fx
        scroll = e.detail/3 * -1;
      }
      return scroll;
    };
    function setDefaultSize(e){
      if(e.shiftKey){
        $(this).removeAttr('height'); // 清掉 height 屬性
        var def_width = $(this).attr('defaultwidth');
        if (def_width){
          $(this).css('width', def_width + 'px');
        }
        e.preventDefault();
        e.stopPropagation();
      }
    }
    function mouseWheelResize(e){
      if (e.shiftKey){
        var scroll = get_mouse_scroll(e)
        $(e.currentTarget).removeAttr('height'); // 清掉 height 屬性

        //defaultwidth是我自己加入的屬性
        if ($(e.currentTarget).attr("defaultwidth")){
          //放大量為每格10%的defaultwidth
          // scale == 每格縮放大小，為 defaultwidth 的 1/10
          var width = $(e.currentTarget).width();
          var scale = $(e.currentTarget).attr('defaultwidth')/10;
          width += scroll * scale;
          if (width > 5){
            // this.width = width;
            $(e.currentTarget).css('width', width + 'px');
          }
        }
        //如果沒有defaultwidth，則從當前的width中取得defaultwidth的值
        else{
          $(e.currentTarget).attr('defaultwidth', $(this).width());
          mouseWheelResize(e);
        }
        e.preventDefault();
        e.stopPropagation();
      }
    }
    function img_ready(){
      $('#lo-article-content').find('img').each(
        function (index, elem){
          elem.addEventListener('DOMMouseScroll', mouseWheelResize, false); //Fx
          elem.addEventListener('mousewheel', mouseWheelResize, false); //chrome
          elem.addEventListener('click', setDefaultSize, false);
        }
      );
    }
    $(document).ready(function(){img_ready();})
  </script>

  <!-- Insert Resource -->
  <div class="modal" id="lo-ir-modal" tabindex="-1" role="dialog" aria-labelledby="lo-ir-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-ir-modal-title" class="modal-title">${_('Insert Resource')}</h4>
        </div>
        <div id="lo-ir-modal-body" class="modal-body">
          <input id='lo-ir-files' type="file" multiple class="form-control">
          <hr/>

          <div class="radio">
            <label>
              <input type="radio" name="lo-ir-restype" id="lo-ir-restype-emb" value="emb" checked>
              ${_('<strong>Embedded:</strong> Insert and show it.')}
            </label>
          </div>
          <div class="radio">
            <label>
              <input type="radio" name="lo-ir-restype" id="lo-ir-restype-att" value="att">
              ${_('<strong>Attachment:</strong> Insert but without display.')}
            </label>
          </div>
          <div id="lo-ir-fmtgroup">
            <div class="input-group">
              <input id="lo-ir-fmt" class="form-control" type="text" tooltip data-title="${_('Setting your insert format. {THIS} mean the resource filename.') | h}" data-placement="auto">
              <div class="input-group-btn">
              <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown">
                ${_("Format") | h}
                <span class="caret"></span>
              </button>
              <ul id="lo-ir-fmtselect" class="dropdown-menu dropdown-menu-right">
              </ul>
              </div>
            </div>
            <p class="help-block text-right small"><span class="glyphicon glyphicon-question-sign"></span> ${_("Hint: Use <code>&lt;img ...</code> format if you want to insert images.")}</p>
          </div>

        </div>
        <div class="modal-footer">
          <button id="lo-ir-submit" class="btn btn-primary" type="button">${_('Upload')}</button>
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->
  <script>
    function lo_ir_fmts_default(){
      var key = 'insert_formats';
      var default_formats = [
        '<img style="width: 500px;" src="{THIS}" /><br/>',
        '<img src="{THIS}" /><br/>',
        '<a href="{THIS}">{THIS}<a>',
        ];
      return default_formats
    };
    function lo_ir_fmts_load(){
      var key = 'insert_formats';
      var j_str = localStorage[key];
      var fmts = null;
      try{ fmts = JSON.parse(j_str); } catch(e){}
      if (fmts == null || fmts == undefined || fmts == ''){
        var fmts = lo_ir_fmts_default();
      }
      return fmts
    };
    function lo_ir_fmtselect_refresh(){
      var fmts = lo_ir_fmts_load();
      var select_obj = $('#lo-ir-fmtselect')
      select_obj.html('');
      for(i=0;i<fmts.length;i++){
        function set_fmt(){
          $('#lo-ir-fmt').val($(this).text())
        }
        var a = $('<a role="menuitem" style="cursor: pointer">').text(fmts[i]).on('click', set_fmt);
        var option = $('<li role="presentation">').append(a)
        select_obj.append(option);
      }
      $('#lo-ir-fmt').val(fmts[0]);
    };
    function lo_ir_fmts_save(formats){
      var key = 'insert_formats';
      var j_str = JSON.stringify(formats);
      localStorage[key] = j_str;
    };
    function lo_ir_fmt_update(fmt){
      var fmts = lo_ir_fmts_load();
      var index = fmts.indexOf(fmt);
      if (index != -1){ // 如果原本存在則刪掉
        fmts.splice(index, 1);
      }
      fmts.unshift(fmt); // 填入這次的新值於第一位置
      if (fmts.length > 10){ // 最長為10
        fmts.length = 10;
      }
      lo_ir_fmts_save(fmts);
    };
    function lo_ir_single_fmt(rid){
      var fmt = $('#lo-ir-fmt').val();
      if (fmt == null || fmt == ''){return}
      var html = fmt.replace(/{THIS}/gi, rid);
      return html;
    };
    function lo_ir_upload(){
      selRestore();

      var res_type = $('input[name=lo-ir-restype]:checked').val();
      var files = $('#lo-ir-files')[0].files;
      var insert_html = '';
      function endswith(string, suffix){
        return string.substr(string.length - suffix.length) === suffix;
      };
      for(var i = 0 ; i < files.length ; i++){
        if( endswith(files[i].name, '.html') ){
          alert('${_('Cannot upload resource with ".html" filename.')}');
          return;
        } else if( /.*?[\|\'\"\[\]\*\:\?\<\>#].*?/.test(files[i].name) ){
          alert("${_('Filename Unacceptable!') | h}");
          return;
        }
      }
      for(var i = 0 ; i < files.length ; i++){
        var uri = new URI(location.path);
        var file = files[i];
        var rid = files[i].name;
        $.ajax({
          url: uri.filename(rid).query('res_type=' + res_type),
          type: 'PUT',
          data: file,
          async: false,
          cache: false,
          contentType: false,
          processData: false
        }).done(function(){
            if(res_type == 'emb'){
              insert_html = insert_html + lo_ir_single_fmt(rid);
            }
            $('#lo-resource-modal-body').html(
              '<div class="alert alert-warning">'+
                '<p><strong>${_("Need Refresh!")}</strong></p>'+
                '<p>${_("Please Refresh this page to re-generate resources list!")}</p>'+
              '</div>');
        }).fail(function(jqXHR, textStatus, errorThrown){
          alert(jqXHR.responseText);
        });
      }
      // post process
      if(res_type == 'emb'){
        document.execCommand('insertHTML', false, insert_html);
        var fmt = $('#lo-ir-fmt').val();
        lo_ir_fmt_update(fmt);
        lo_ir_fmtselect_refresh();
        img_ready();
      }
      $('#lo-ir-modal').modal('hide');
    };
    // Real Work
    lo_ir_fmtselect_refresh();
    $('#lo-ir-modal').on('show.bs.modal', function(){
      selSave();
    });
    $('#lo-ir-modal').on('shown.bs.modal', function(){
      $('#lo-ir-files').focus();
    });
    $('#lo-ir-modal').on('hidden.bs.modal', function(){
      selRestore();
    });
    $('#lo-ir-submit').on('click', lo_ir_upload);
    $('#lo-ir-restype-att').on('click', function(){
      $('#lo-ir-fmtgroup').hide();
    });
    $('#lo-ir-restype-emb').on('click', function(){
      $('#lo-ir-fmtgroup').show();
    });
    $('#lo-ir-fmtselect').on('change', function(){
      $('#lo-ir-fmt').val($('#lo-ir-fmtselect').val());
    });

  </script>
  
  <!-- Insert Source Code -->
  <div class="modal" id="lo-is-modal" tabindex="-1" role="dialog" aria-labelledby="lo-is-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-is-modal-title" class="modal-title">${_('Insert Source Code')}</h4>
        </div>
        <div id="lo-is-modal-body" class="modal-body">

      <form role="form">
        <div class="form-group">
          <label tooltip data-title="${_('The following code will insert to your paper.')}" data-placement="auto" for="lo-is-content">${_('HTML Code:')}</label>
          <textarea id="lo-is-content" class="form-control" style="max-width: 100%; font-family: monospace;" rows="6"></textarea>
        </div>
      </form>
      <div class="panel panel-default">
        <div id="lo-is-preview" class="panel-body lo-content"></div>
      </div>

        </div>
        <div class="modal-footer">
          <button id="lo-is-submit" class="btn btn-primary" type="button">${_('Insert')}</button>
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->
  <script>
    function lo_is_preview_update(){
      var inshtml = $('#lo-is-content').val();
      $('#lo-is-preview').html(inshtml);
    };
    function lo_is_insert(){
      $('#lo-is-modal').modal('hide');
      selRestore();
      var inshtml = $('#lo-is-content').val();
      document.execCommand("insertHTML", false, inshtml);
    };
    $('#lo-is-modal').on('show.bs.modal', function(){
      selSave();
      var sel = rangy.getSelection();
      var ori_html = sel.toHtml();
      $('#lo-is-content').val(ori_html);
      lo_is_preview_update();
    });
    $('#lo-is-modal').on('shown.bs.modal', function(){
      $('#lo-is-content').focus().select();
    });
    $('#lo-is-modal').on('hidden.bs.modal', function(){
      selRestore();
    });
    $('#lo-is-content')
      .on('input', lo_is_preview_update)
      .on('keypress', function(e){
          if (e.keyCode == $.ui.keyCode.ENTER && !e.shiftKey) {
            e.preventDefault();
            lo_is_insert();
            return false;
          };
        });
    $('#lo-is-submit').on('click', lo_is_insert);
  </script>

  <script>
    $(document).ready(function(){
      rangy.init();
      $(window).on('beforeunload', selSave);

      selRestore();
    });

    // datetime insert
    function get_time_insert_format(){
      var insert_format = localStorage['time_insert_format'];
      if(insert_format == undefined || insert_format == null || insert_format == '') {
        insert_format = '%H:%M:%S';
        localStorage['time_insert_format'] = insert_format;
      }
      return insert_format;
    };
    function get_date_insert_format(){
      var insert_format = localStorage['date_insert_format'];
      if(insert_format == undefined || insert_format == null || insert_format == '') {
        insert_format = '%Y-%m-%d';
        localStorage['date_insert_format'] = insert_format;
      }
      return insert_format;
    };
    function time_insert(){
      var d = new Date();
      var insert_format = get_time_insert_format();
      document.execCommand("insertHTML", false, d.strftime(insert_format));
      return false;
    };
    function date_insert(){
      var d = new Date();
      var insert_format = get_date_insert_format();
      document.execCommand("insertHTML", false, d.strftime(insert_format));
      return false;
    };

    // 增大所選位置的字型
    function increase_font_size(){
      var cfs = document.queryCommandValue("fontSize");
      if(!cfs){
        document.execCommand('increaseFontSize');
      } else{
        var size = parseInt(cfs) + 1;
        if (size<=7)
          document.execCommand('fontSize', false, size);
      }
      return false;
    };
    // 減小所選位置的字型
    function decrease_font_size(){
      var cfs = document.queryCommandValue("fontSize");
      if(!cfs){
        document.execCommand('decreaseFontSize');
      } else {
        var size = parseInt(cfs) - 1;
        if (size>0)
          document.execCommand('fontSize', false, size);
      }
      return false;
    };
  </script>

  <!-- 超連結轉化 -->
  <div class="modal" id="lo-wiki-create-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 class="modal-title" id="myModalLabel">${_('Create a Internal Link') | h}</h4>
        </div>
        <div class="modal-body">
          <div class="panel panel-primary">
            <div class="panel-heading">
              <strong>${_("The Same Book's Papers") | h}</strong>
            </div>
            <div id="lo-wiki-create-samebook-panel" class="panel-body">
            </div>
          </div>
          <br/>
          <div class="panel panel-warning">
            <div class="panel-heading">
              <strong>${_("Other Book's Papers") | h}</strong>
            </div>
            <div id="lo-wiki-create-otherbook-panel" class="panel-body">
            </div>
            <div class="panel-footer" style="color: gray; font-size: small;">
              <span class="glyphicon glyphicon-exclamation-sign"></span> <span>${_('Caution: Link to the other books may not reliable...') | h}</span>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close') | h}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->
  <script>
    $('#lo-wiki-create-modal').on('show.bs.modal', function(){
      $('.modal').modal('hide');
      selSave();
    });
    $('#lo-wiki-create-modal').on('hidden.bs.modal', function(){
      selRestore();
    });
    // 轉化為超連結
    function create_link(){
      var seltext = window.getSelection().toString();
      if (seltext == ''){return;}

      var at_index_1 = seltext.lastIndexOf('@');
      var at_index_2 = seltext.lastIndexOf('＠');
      var at_index = -1;
      if(at_index_1 == -1 && at_index_2 == -1){
        at_index = -1;
      } else {
        if (at_index_1 == -1){
          at_index = at_index_2;
        } else if(at_index_2 == -1){
          at_index = at_index_1;
        } else {
          at_index = Math.min(at_index_1, at_index_2);
        }
      }

      if(at_index == -1){ //沒找到@
        var has_at = false;
        var display = seltext;
        var link = seltext;
      } else {
        var has_at = true;
        var display = seltext.substring(0, at_index);
        var link = seltext.substring(at_index+1);
      }
      //分析link，檢查link是否為有效連結
      var valid = link.match(/^(?:(?:https?|ed2k|ftp|samba|file):\/\/|magnet:\?)/i);
      if(valid){
        //如果可行，試著轉換為相對連結
        var linkparser = document.createElement('a'); //link parser
        linkparser.href = link;
        //轉換的條件為protocol一樣且host一樣
        if(location.protocol == linkparser.protocol && location.host == linkparser.host){
          var uri = new URI(link);
          link = uri.relativeTo(location.href);
        }
        var html = '<a href="' + link + '">' + display + '</a>';
        document.execCommand('insertHTML', false, html);
      } else { // 偵測 wiki 聯結
        var targets = $('#lo-bookshelf')
          .find('a:contains(' + link + ')' );
        //var mbody = $('#lo-wiki-create-modal .modal-body').html('');
        var smbook = $('#lo-wiki-create-samebook-panel').html('');
        var otbook = $('#lo-wiki-create-otherbook-panel').html('');
        var modal = $('#lo-wiki-create-modal');
        if (targets.length == 0){
          return;
        } else {
          targets.each(function(index, elem){
            var href = $(elem).attr('href');
            var text = $(elem).text();
            var button = $('<button/>', {
              class: "btn",
              type: "button",
              text: text,
              click: function(){
                  modal.modal('hide');
                  if (has_at){
                    var html = '<a href="' + href + '">' + display + '</a>';
                  } else {
                    var html = '<a href="' + href + '">' + text + '</a>';
                  }
                  document.execCommand('insertHTML', false, html);
                }
              });
            var preview_btn = $('<a/>', {
              role: "button",
              class: "btn btn-default",
              href: href,
              target: "_blank",
              html: "<span class='glyphicon glyphicon-search'></span>"
              }).attr('tabindex', '-1');
            var btn_group = $('<div/>', {
              class: "btn-group",
              style: "margin: 3px;"
              });
            btn_group.append(button).append(preview_btn);
            var uri = new URI(href);
            var bid = uri.segment()[1];
            if (bid == "${book.bid}") {
              button.addClass('btn-default');
              smbook.append(btn_group);
            } else {
              button.addClass('btn-default');
              otbook.append(btn_group);
            }
          });
          modal.modal();
          $('#lo-wiki-create-modal .modal-body button').first().focus();
        };
      }
    }
    // color change
    function color_change(){
      $('#lo-colorchange-modal').modal('toggle');
    };
    // insert resource
    function insert_resource(){
      $('#lo-ir-modal').modal('toggle');
    };
    // insert source code
    function insert_source(){
      $('#lo-is-modal').modal('toggle');
    };

    // hotkey table
    var hk = {
      'p': 'Alt+0',
      'h1': 'Alt+1',
      'h2': 'Alt+2',
      'h3': 'Alt+3',
      'h4': 'Alt+4',
      'h5': 'Alt+5',
      'h6': 'Alt+6',
      'blockquote': 'Alt+7',
      'pre': 'Alt+8',

      'alignleft': 'Alt+,',
      'aligncenter': 'Alt+M',
      'alignright': 'Alt+.',
      // 'indent': 'Alt+]',  // cannot set directly
      // 'outdent': 'Alt+[', // cannot set directly
      'ol': 'Alt+O',
      'ul': 'Alt+P',

      'insres': 'Alt+I',
      'inssrc': 'Ctrl+Alt+I',
      'instime': 'Alt+T',
      'insdate': 'Alt+D',

      'unformat': 'Ctrl+K',
      'unlink': 'Ctrl+Shift+K',
      'link': 'Ctrl+L',
      'bold': 'Ctrl+B',
      'italic': 'Ctrl+I',
      'underline': 'Ctrl+U',
      'strike': 'Ctrl+S',
      'bigger': 'Alt+Up',
      'smaller': 'Alt+Down',
      'colorchange': 'Ctrl+E',
      'sup': 'Alt+K',
      'sub': 'Alt+J',

      // 'ioc': 'Alt+Q',     // not in here
      // 'bookshelf': 'Alt+A', // not in here
      // 'search': 'F9',

      // 'pcreate': 'Alt+N',   // not in here
      // 'psubcreate': 'Ctrl+Alt+N', // not in here
      // 'pdelete': 'Shift+Delete'
      };

    % if 'e' in a_type:

      // 移除格式
      shortcut.add(hk.unformat,function() {
        document.execCommand("removeFormat");
      });
      shortcut.add(hk.unlink,function() {
        document.execCommand("unlink");
      });

      // 基本格式
      shortcut.add(hk.bold,function() {
        document.execCommand("bold");
      });
      shortcut.add(hk.italic,function() {
        document.execCommand("italic");
      });
      shortcut.add(hk.underline,function() {
        document.execCommand("underline");
      });
      shortcut.add(hk.strike,function() {
        document.execCommand("strikethrough");
      });
      shortcut.add(hk.sup,function() {
        document.execCommand("superscript");
      });
      shortcut.add(hk.sub,function() {
        document.execCommand("subscript");
      });
      shortcut.add(hk.bigger,function() {
        increase_font_size();
      });
      shortcut.add(hk.smaller,function() {
        decrease_font_size();
      });
      shortcut.add(hk.colorchange,function() {
        color_change();
      });
      
      // 段落標記
      shortcut.add(hk.p, function() {
        document.execCommand("formatblock", false,"p");
      });
      shortcut.add(hk.h1,function() {
        document.execCommand("formatblock", false,"h1");
      });
      shortcut.add(hk.h2,function() {
        document.execCommand("formatblock", false,"h2");
      });
      shortcut.add(hk.h3,function() {
        document.execCommand("formatblock", false,"h3");
      });
      shortcut.add(hk.h4,function() {
        document.execCommand("formatblock", false,"h4");
      });
      shortcut.add(hk.h5,function() {
        document.execCommand("formatblock", false,"h5");
      });
      shortcut.add(hk.h6,function() {
        document.execCommand("formatblock", false,"h6");
      });
      shortcut.add(hk.blockquote,function() {
        document.execCommand("formatblock", false,"blockquote");
      });
      shortcut.add(hk.pre,function() {
        document.execCommand("formatblock", false,"pre");
      });

      // 左右對齊
      shortcut.add(hk.alignleft,function() {
        document.execCommand("JustifyLeft");
      });
      shortcut.add(hk.alignright,function() {
        document.execCommand("JustifyRight");
      });
      shortcut.add(hk.aligncenter,function() {
        document.execCommand("JustifyCenter");
      });

      // 縮進
      shortcut.add("Alt+",function() {
        document.execCommand("Indent");
      }, { 'keycode':221 }); //右方括號的keycode (Alt+])
      shortcut.add("Alt+",function() {
        document.execCommand("Outdent");
      }, { 'keycode':219 }); //左方括號的keycode (Alt+[)

      // 列表
      shortcut.add(hk.ul,function() {
        document.execCommand("InsertUnorderedList");
      });
      shortcut.add(hk.ol,function() {
        document.execCommand("InsertOrderedList");
      });

      // 建立超連結
      shortcut.add(hk.link,function() {
        create_link();
      });
      // 插入時間
      shortcut.add(hk.instime,function() {
        time_insert();
      });
      shortcut.add(hk.insdate,function() {
        date_insert();
      });
      shortcut.add(hk.insres,function() {
        insert_resource();
      });
      shortcut.add(hk.inssrc,function() {
        insert_source();
      });

    % endif

  </script>
</%block>
