<%inherit file="base.mako"/>

<%block name="lo_head_title">
  ${ _('LoNote Hotkey Table') | h}
</%block>

<%block name="lo_nav_header">
  <a id="lo-nav-title" class="navbar-brand"> ${_('LoNote Hotkey Table') | h} </a>
</%block>

<%block name="lo_head_append">
  <style>
    .lo-content td:last-child {
      font-style: italic;
    }
  </style>
</%block>

<%namespace file="element.mako" import="*"/>

<%block name="lo_nav_tools">
  <div class="btn-group">
    ${btn_bookshelf()}
    ${btn_ioc()}
    ${btn_configure_start()}
  </div>
</%block>

<%block name="lo_data">
  ${modal_bookshelf()}
  ${modal_ioc()}
  ${modal_configure_start()}
</%block>

<%block name="lo_article_content">
  <h1 class="text-center">${_('LoNote Hotkey Table')}</h1>
  <p class="text-center text-warning">${_('Hint: Almost all editing function only have hotkey but no button.')}</p>
  <table class="table table-striped table-bordered" style="max-width: 600px; margin-left: auto; margin-right: auto;">
    <thead>
    </thead>

    <tbody>
      <tr class="info"><th colspan="2"><h2>${_('Note Management')}</h2></th></tr>
      <tr class="info"><th style="min-width: 200px;">${_('The Hotkey')}</th><th>${_('Description')}</th></tr>

      <tr><td><kbd>Alt</kbd> + <kbd>N</kbd></td><td>${_('Create a new paper.')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>Alt</kbd> + <kbd>N</kbd></td><td>${_('Create a new sub-paper.')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>Alt</kbd> + <kbd>S</kbd></td><td>${_('Create a new section')}</td></tr>
      <!-- <tr><td>Shift + Delete</td><td>${_('Remove the current note.')}</td></tr> -->

      <tr class="info"><th colspan="2"><h2>${_('Content Editing')}</h2></th></tr>

      <tr class="info"><th>${_('The Hotkey')}</th><th>${_('Basic Formating')}</th></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>K</kbd></td><td>${_('Remove format')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>B</kbd></td><td>${_('Bold')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>I</kbd></td><td>${_('Italic')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>U</kbd></td><td>${_('Underline')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>S</kbd></td><td>${_('Strike')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>↑</kbd></td><td>${_('Font size increase')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>↓</kbd></td><td>${_('Font size decrease')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>E</kbd></td><td>${_('Color change')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>K</kbd></td><td>${_('Super script')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>J</kbd></td><td>${_('Sub script')}</td></tr>

      <tr class="info"><th>${_('The Hotkey')}</th><th>${_('Paragraph Formating')}</th></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>0</kbd></td><td>${_('Paragraph')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>1</kbd> ~ <kbd>6</kbd></td><td>${_('Heading 1 ~ 6')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>7</kbd></td><td>${_('Blockquote')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>8</kbd></td><td>${_('Code (pre block)')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>P</kbd></td><td>${_('Unordered List')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>O</kbd></td><td>${_('Ordered List')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>]</kbd></td><td>${_('Indent')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>[</kbd></td><td>${_('Outdent')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>,</kbd></td><td>${_('Justify Left')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>.</td><td>${_('Justify Right')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>M</td><td>${_('Justify Center')}</td></tr>

      <tr class="info"><th>${_('The Hotkey')}</th><th>${_('Inserting & Linking')}</th></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>I</kbd></td><td>${_('Insert Resource')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>Alt</kbd> + <kbd>I</kbd></td><td>${_('Insert (or edit) HTML Source Code.')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>L</kbd></td><td>${_('Create a Link of Selected Text.<br/>(Format: TEXT@LINK or only LINK. The LINK may also be a paper name for internal linking.)')}</td></tr>
      <tr><td><kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>K</kbd></td><td>${_('Remove link')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>D</kbd></td><td>${_('Insert Date-stamp')}<br/>${_('You can set your format in Global Menu.')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>T</kbd></td><td>${_('Insert Time-stamp')}<br/>${_('You can set your format in Global Menu.')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>Z</kbd></td><td>${_('Use the Wrapper to wrap current selection.')}<br/>${_('You can set your wrapper in Global Menu.')}</td></tr>

      <tr class="info"><th>${_('The Hotkey')}</th><th>${_('Image Resizing')}</th></tr>
      <tr><td><kbd>Shift</kbd> + <kbd>${_('Mousewheel')}</kbd><br/>${_('(on image)')}</td><td>${_('Resize the image.')}</td></tr>
      <tr><td><kbd>Shift</kbd> + <kbd>${_('LeftClick')}</kbd><br/>${_('(on image)')}</td><td>${_('Resize the image to default width.')}</td></tr>

      <tr class="info"><th colspan="2"><h2>${_('Other')}</h2></th></tr>
      <tr class="info"><th>${_('The Hotkey')}</th><th>${_('Description')}</th></tr>

      <tr><td><kbd>F1</kbd></td><td>${_('Open the Start Page')}</td></tr>
      <tr><td><kbd>F2</kbd></td><td>${_('Toggle the Papermenu')}</td></tr>
      <tr><td><kbd>F4</kbd></td><td>${_('Open this hotkey table')}</td></tr>
      <tr><td><kbd>F8</kbd></td><td>${_('Open the Moving Page')}</td></tr>
      <tr><td><kbd>F10</kbd></td><td>${_('Toggle view/edit mode')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>Q</kbd></td><td>${_('Toggle the Bookshelf')}</td></tr>
      <tr><td><kbd>Q</kbd> ${_('(In bookshelf)')}</td><td>${_('Move to top')}</td></tr>
      <tr><td><kbd>A</kbd> ${_('(In bookshelf)')}</td><td>${_('Move to current paper')}</td></tr>
      <tr><td><kbd>Z</kbd> ${_('(In bookshelf)')}</td><td>${_('Move to bottom')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>A</kbd></td><td>${_('Toggle the Index of Content')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>S</kbd></td><td>${_('Toggle sections menu')}</td></tr>
      <tr><td><kbd>Alt</kbd> + <kbd>W</kbd></td><td>${_('Toggle search window')}</td></tr>

      <tr class="info"><th colspan="2"><h2>${_('Browser Build-in')}</h2></th></tr>
      <tr class="info"><th>${_('Browser')}</th><th>${_('Document')}</th></tr>
      <tr><td>Firefox</td><td>${_('See the')} <a href="http://support.mozilla.org/kb/keyboard-shortcuts-perform-firefox-tasks-quickly">Mozilla Support</a> ${_('(Multi language)')}</td></tr>
      <tr><td>Chrome / Chromium</td><td>${_('See the')} <a href="https://support.google.com/chrome/bin/answer.py?topic=25799&answer=171571">Chrome Help</a> ${_('(Multi language)')}</td></tr>
    </tbody>

    <tfoot>
    </tfoot>
  </table>
</%block>
