<%inherit file="base.mako"/>

<%block name="lo_head_title">
  ${_('Permission Control') | h} -
  % if config['SITEINFO']['site_name']:
    ${config['SITEINFO']['site_name'] | h}
  % else:
    ${_('LoNote') | h}
  % endif
</%block>

<%block name="lo_nav_header">
  <a id="lo-nav-sid" class="navbar-brand">${_('Permission Control') | h}</a>
</%block>

<%block name="lo_article_content">
<div class="form-horizontal" role="form">
  <div class="form-group">
    <label class="col-sm-3 control-label">${_("Current Access Level") | h}</label>
    <div class="col-sm-4">
      <%
        if 'e' in a_type:
          a_text = "<span class='label label-success' tooltip data-title='" + _("You can do anything. Just like a god.") + "'><span class='glyphicon glyphicon-ok'></span> " + _("Full Access") + "</span>"
        elif 'v' in a_type:
          a_text = "<span class='label label-warning' tooltip data-title='" + _("Can view and download all data, but cannot make any change.") + "'><span class='glyphicon glyphicon-eye-open'></span> " + _("View Only") + "</span>"
        else:
          a_text = "<span class='label label-danger' tooltip data-title='" + _("This page is the only page you can see. Please change your access level.") + "'><span class='glyphicon glyphicon-remove'></span> " + _("Be Refused") + "</span>"
      %>
      % if a_type:
        <a class='btn btn-default pull-right' role='button' href='/'>${_("Back to Start Page") | h}</a>
      % endif
      <p class="form-control-static">${a_text}</p>
    </div>
  </div>
  <div class="form-group">
    <label class="col-sm-3 control-label" for="lo-authcode-input">${_('Authorization Code') | h}</label>
    <div class="col-sm-4">
      <div class="input-group" style="">
        <input id="lo-authcode-input" type="password" class="form-control" placeholder="${_('Input new auth code then change access level') | h}" value="">
        <span class="input-group-btn">
          <button id="lo-authcode-btn" class="btn btn-primary" type="button">${_('Submit')}</button>
        </span>
      </div>
      % if config.get('AUTHCODE', 'code_hint'):
        <p class="help-block text-right small"><span class="glyphicon glyphicon-question-sign" tooltip data-title="${_("Hint of code") | h}"></span> ${_(config.get('AUTHCODE', 'code_hint'))}</p>
      % endif
    </div>
  </div>
</div>
</%block>

<%block name="append_script">
  <script>
    function submit_auth(){
      
      setCookie('auth_code', hex_md5($('#lo-authcode-input').val()), 365);
      location.reload();
    };
    $('#lo-authcode-btn').on('click', submit_auth)
    $('#lo-authcode-input').keypress(function(){
      $(window).keydown(function(event){
        if(event.keyCode == 13) {
          event.preventDefault();
          submit_auth();
        }
      });
    });
    $('#lo-authcode-input').focus();
  </script>
</%block>
