<%inherit file="base.mako"/>

<%block name="lo_head_title">
  % if config['SITEINFO']['site_name']:
    ${config['SITEINFO']['site_name'] | h}
  % else:
    ${_('LoNote Personal Notebook') | h}
  % endif
</%block>

<%block name="lo_nav_header">
  <a id="lo-nav-title" class="navbar-brand">
    % if config['SITEINFO'].get('site_name'):
      ${config['SITEINFO'].get('site_name') | h}
    % else:
      ${_('LoNote Personal Notebook') | h}
    % endif
  </a>
</%block>

<%namespace file="element.mako" import="*"/>

<%block name="lo_nav_tools">
  <div class="btn-group">
    ${btn_search()}
    ${btn_bookshelf()}
    ${btn_configure_start()}
  </div>
</%block>

<%block name="lo_data">
  ${modal_search()}
  ${modal_bookshelf()}
  ${modal_configure_start()}
</%block>



<%block name="lo_article_content">

  <p><br/></p>

  <div class="row" style="width: 100%; margin-left: auto; margin-right: auto;">
  <%
    rr = [] # 篩掉不存在的項目
    for bid, pid, sid in recent_readed:
      try:
        bs[bid].paper(pid).sections.data_meta(sid)
      except: pass
      else:
        rr.append((bid, pid, sid))
  %>
  <div class="col-lg-6 col-md-6 lo-recent">
    % if rr:
      <div class="panel panel-primary">
        <div class="panel-heading">
          <h1 class="panel-title"><strong>${_('Recent Readed')}</strong></h1>
        </div>
        <div class="panel-body">
          <div class="list-group">
            % for bid, pid, sid in rr:
              % try:
                <a class="list-group-item" href="/edit/${bid}/${pid}/${sid}.html">
                  % if sid == type(bs[bid].paper(pid)).default_sid:
                    <span class="label label-primary pull-right" tooltip data-title="${bs[bid].paper(pid).sections.data_meta(sid).get('desc')}" data-placement="left" data-trigger="manual">${sid | h}</span>
                  % else:
                    <span class="label label-warning pull-right" tooltip data-title="${bs[bid].paper(pid).sections.data_meta(sid).get('desc')}" data-placement="left" data-trigger="manual">${sid | h}</span>
                  % endif
                  <big>${bs[bid].paper(pid).name}</big>
                  <br/>
                  <small style="color: gray; font-style: italic; margin-left: 1em;">${bs[bid].paper(pid).desc}</small>
                </a>
              % except:
                pass
              % endtry
            % endfor
          </div>
        </div>
        <div class="panel-footer">
          <span style="color: gray;">${_('Recent Readed')}</span>
        </div>
      </div>
    % endif
  </div>

  <%
    re = [] # 篩掉不存在的項目
    for bid, pid, sid in recent_edited:
      try:
        bs[bid].paper(pid).sections.data_meta(sid)
      except: pass
      else:
        re.append((bid, pid, sid))
  %>
  <div class="col-lg-6 col-md-6 lo-recent">
    % if re:
      <div class="panel panel-primary">
        <div class="panel-heading">
          <h1 class="panel-title"><strong>${_('Recent Edited')}</strong></h1>
        </div>
        <div class="panel-body">
          <div class="list-group">
            % for bid, pid, sid in re:
              % try:
                <a class="list-group-item" href="/edit/${bid}/${pid}/${sid}.html">
                  <%
                    mtime = bs[bid].paper(pid).sections.data_meta(sid).get('mtime')
                  %>
                  <span class="badge pull-right lo-time" time="${mtime | h}"></span>
                  <big>${bs[bid].paper(pid).name}</big>
                  <br/>
                  % if sid == type(bs[bid].paper(pid)).default_sid:
                    <span class="label label-primary pull-right" tooltip data-title="${bs[bid].paper(pid).sections.data_meta(sid).get('desc')}" data-placement="left" data-trigger="manual">${sid | h}</span>
                  % else:
                    <span class="label label-warning pull-right" tooltip data-title="${bs[bid].paper(pid).sections.data_meta(sid).get('desc')}" data-placement="left" data-trigger="manual">${sid | h}</span>
                  % endif
                  <small style="color: gray; font-style: italic; margin-left: 1em;">${bs[bid].paper(pid).desc}</small>
                </a>
              % except:
                pass
              % endtry
            % endfor
          </div>
        </div>
        <div class="panel-footer">
          <span style="color: gray;">${_('Recent Edited')}</span>
        </div>
      </div>
    % endif
  </div>

  </div>

  % if rr or re:
    <script>
    $('.lo-recent a').hover(function(e){
      $(e.target).find('[tooltip]').tooltip('show')
    }, function(e){
      $(e.target).find('[tooltip]').tooltip('hide')
    });
    </script>
    <hr/>
  % endif


  <div class="panel-group" id="lo-start-info">
    <div class="panel panel-info">
      <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-start-info" data-target="#lo-start-info-1">
        <h1 class="panel-title">
          <strong>
            ${_('How to Start?')}
          </strong>
        </h1>
      </div>
      <div id="lo-start-info-1" class="panel-collapse collapse in">
        <div class="panel-body">
          <div class="alert alert-info">
            <p>${_("<strong>Browser Support:</strong> This site primary support <strong>Firefox 17+</strong> & <strong>Chromium 26+</strong>")} ♬</p>
          </div>
          <ol>
            <li>${_("If you don't have any book, please check the right-top corner and create one first!")}</li>
            <li>${_('Press <kbd>&lt;F4&gt;</kbd> key and checkout the hotkey table.')}</li>
            <li>${_('Write anything you want!')}</li>
          </ol>
        </div>
      </div>
    </div>

    <div class="panel panel-info">
      <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-start-info" data-target="#lo-start-info-2">
        <h1 class="panel-title">
          <strong>
            ${_('For LoNote 2 User')}
          </strong>
        </h1>
      </div>
      <div id="lo-start-info-2" class="panel-collapse collapse">
        <div class="panel-body">
          <p>${_('You can upload your old ".lobook" file directly. The LoNote 3 will finish all other things ^_^')}</p>
        </div>
      </div>
    </div>

    <div class="panel panel-info">
      <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-start-info" data-target="#lo-start-info-3">
        <h1 class="panel-title">
          <strong>
            ${_('More Help?')}
          </strong>
        </h1>
      </div>
      <div id="lo-start-info-3" class="panel-collapse collapse">
        <div class="panel-body">
          <p>${_('If you need more help, please see:')}</p>
          <ul>
            <li><a href="/hotkey.html">${_('The Hotkey Table') | h}</a></li>
            <li><a href="${info.download_url}">${_('Download new version?') | h}</a></li>
            <li><a href="${info.documentpage}">${_('The document box') | h}</a></li>
            <li><a href="${info.forumpage}">${_('Talk something in our forum') | h}</a></li>
            <li><a href="${info.homepage}">${_('LoNote project home page') | h}</a></li>
            <li><a href="${info.bugpage}">${_('Report bugs') | h}</a></li>
            <li><a href="${info.designer_blog}">${_('Designer blog') | h}</a></li>
          </ul>
        </div>
      </div>
    </div>

  </div>

  <p><br/></p>

</%block>

<%block name="append_script">

  <!-- Disable Scorll Restore -->
  <script>
    $(document).ready(function(){$(document).scrollTop(0);});
  </script>

</%block>
